#Usage: perl gen_seq.pl <ntax> <seqlen> <insthresh> <delthresh> <modeltree> 
#<outputbase>

$ntax = shift;
$seqlen = shift;
$insertthresh = shift;
$deletethresh = shift;
$modeltree = shift;
$outputbase = shift;
$fs=shift;

#gen seqs
open(OUT, ">rose_in.$fs");
print OUT "\%include protein-defaults\n";
print OUT "SequenceNum = $ntax\n";
print OUT "SequenceLen = $seqlen\n";
print OUT "ChooseFromLeaves = True\n";
open(IN, "$modeltree"); $tree=<IN>; close IN;
print OUT "TheTree = $tree\n";
print OUT "TheInsertThreshold = $insertthresh\n";
print OUT "TheDeleteThreshold = $deletethresh\n";
print OUT "OutputFilebase = \"$outputbase\"\n";
print OUT "AlignmentFormat = \"FASTA\"\n";
$rootseq=`perl gen_root_seq.pl $seqlen`;
print OUT "TheSequence = \"$rootseq\"\n";
$mutprob=`perl gen_mut_vector.pl $seqlen 0.25 30`;
print OUT $mutprob;
close OUT;

system "./rose rose_in.$fs > /dev/null";
`/bin/rm rose_in.$fs`;

